////////////////////////////////////////////////////////////////////////////////
// File         : ObjPrint.cpp
// Subsystem    : Graph
// Component    : trace objects
// Author       : Josef Huebl, (Josef.Huebl@sss.de)
// Description  : implementation of the class ObjPrint
////////////////////////////////////////////////////////////////////////////////
// Copyright (C) Triple-S GmbH (www.sss.de) 2003
// Alle Rechte vorbehalten. All Rights Reserved.
//
// The reproduction, transmission or use of this document or its contents is
// not permitted without express written authority.
// Offenders will be liable for damages. All rights, including rights created
// by patent grant or registration of a utility model or design, are reserved.
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// History:
// 10.10.03    Josef Huebl       created
// 17.12.03    Josef Huebl       1. released version.
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Hints:      
//     
//     
////////////////////////////////////////////////////////////////////////////////


#include "ObjPrint.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

ObjPrint::ObjPrint( const char *type, const char *name ) : m_copy(0)
{
	strncpy( m_type, type, ObjPrintNameSize );
	strncpy( m_name, name, ObjPrintNameSize );
	strncpy( m_fullName, name, ObjPrintNameSize );
}


ObjPrint::ObjPrint( const ObjPrint &obj, const char *name )
{
	Copy( obj, name );
}



ObjPrint::~ObjPrint()
{

}


//////////////////////////////////////////////////////////////////////
// public
//////////////////////////////////////////////////////////////////////

void ObjPrint::Print( char * comment ... ) const
{
	printf( "\n%s ", m_type );
	printf( "%s", GetFullName() );

	if ( comment[0] !=  0 )  // empty string?
	{
		int i;
		char *arg[10];

		va_list ap;
		va_start( ap, comment );

		for (i=0; i<10; i++)
		{
			arg[i] = va_arg(ap, char *);
			if ( arg[i] == NULL )
				break;
		}

		printf( "  // " );
		printf( comment, arg[0], arg[1], arg[2], arg[3], arg[4], arg[5], arg[6], arg[7], arg[8], arg[9] );
		va_end( ap );
	}

	printf( "\n{\n" );
	PrintBody();
	printf( "}\n\n" );
}


//////////////////////////////////////////////////////////////////////
// protected
//////////////////////////////////////////////////////////////////////

void ObjPrint::Copy( const ObjPrint &obj, const char *name )
{
	strncpy( m_type, obj.m_type, ObjPrintNameSize );

	if (!strcmp( name, ObjPrintNoname ) )
	{
		strncpy( m_name, obj.m_name, ObjPrintNameSize );
		m_copy = obj.m_copy + 1;
	}
	else
	{
		strncpy( m_name, name, ObjPrintNameSize );
		m_copy = 0;
	}

	if (m_copy == 0)
		sprintf( m_fullName, "%s", m_name );
	else
		sprintf( m_fullName, "Copy%u of %s", m_copy, m_name );
}

