#include <iostream>
#include "HnetUniversePrint.h"
#include "HnetPrint.h"

NodeAttribute<int> id;	

typedef struct{
char name[200];
}stringA;

int main()
{
	HnetUniversePrint universe( "universe" );

	IsoTypeNode te1 = universe.CreateIsoTypeElementary( 1, 2 );
	IsoTypeNode te2 = universe.CreateIsoTypeElementary( 2, 3 );
	IsoTypeNode t3 = universe.CreateIsoType( );
	
	universe.Print(" 111 ");

	Hnet &he1 = universe.GetHnet( te1 );
	HnetPrint hpe1( &universe, he1, "he1" );
	hpe1.Print();

	printf("he1: Entries: %d Exits: %d\n", he1.NumberOfEntries( he1.Root()), he1.NumberOfExits(he1.Root()) );
	printf("he1: outer Entries: %d outer Exits: %d\n", he1.NumberOfOuterEntries(), he1.NumberOfOuterExits() );

	Hnet &h3 = universe.GetHnet( t3 );
	if ( h3.Elementary() )
		printf(" h3 is elementary.\n" );

	printf("Entries: %d Exits: %d\n", h3.NumberOfOuterEntries(), h3.NumberOfOuterExits() );

	NodeAttribute<char> name;
	Node x;
	Edge e;

	x = h3.AddSubcentre( te1 );
   name[x] = 'A';

   Node entry = h3.FirstEntry( e, x );

   name[entry] = '1';

   Node exit = h3.FirstExit( e, x );

   name[exit] = 'a';

   exit = h3.NextExit( e );

  name[exit] = 'b';

	h3.AddSubcentre( te2 );
	h3.AddSubcentre( te2 );


 
	HnetPrint hp3( &universe, h3, "h3" );
	hp3.Print();

	IsoTypeNode t4 = universe.CreateIsoType( );
	Hnet &h4 = universe.GetHnet( t4 );


	HnetPrint hp4( &universe, h4, "h4" );
	hp4.Print();

	universe.Print( "universe before flat" );
	h4.MakeFlat();
	universe.Print( "universe after flat" );

	HnetPrint hp4after( &universe, h4, "h4 after makeFlat()" );
	hp4after.Print();

	universe.DelIsoType( t3 );
	universe.Print( "universe after Del t3" );

	return 0;
}

