#include <iostream>
#include "SnetPrint.h"


int main()
{
	SnetPrint snet( "snet" );
	Node s1, s2, s3, y1, y2, y3, x1, x2, entry1, entry2, entry3, exit1, exit2;
	Edge e;

	y1 = snet.AddOuterEntry();
	y2 = snet.AddOuterEntry();
	y3 = snet.AddOuterEntry();
	x1 = snet.AddOuterExit();
	x2 = snet.AddOuterExit();

	s1 = snet.AddSubcentre( 3, 2 );
	s2 = snet.AddSubcentre( 1, 1 );
	s3 = snet.AddSubcentre( 1, 1 );

	entry1 = snet.FirstEntry( e, s1 );
	entry2 = snet.NextEntry( e );
	entry3 = snet.NextEntry( e );
	exit1 = snet.FirstExit( e, s1 );
	exit2 = snet.NextExit( e );

	snet.Connect( y1, entry1 );
	snet.Connect( y2, entry1 );
	snet.Connect( y3, entry3 );

	entry1 = snet.FirstEntry( e, s2 );
	entry2 = snet.FirstEntry( e, s3 );
	snet.Connect( exit1, entry1 );
	snet.Connect( exit1, entry2 );
	snet.Connect( exit2, entry1 );
	snet.Connect( exit2, entry2 );

	exit1 = snet.FirstExit( e, s2 );
	snet.Connect( exit1, x1 );
	snet.Connect( exit1, x2 );

	snet.Print();

	SnetPrint snetCopy( snet );

	snetCopy.Print();

	snet.Replace( s1, snetCopy );
	snet.Print( "%s replaced ", snet.Str( s1 ) );

	
	return 0;
}

