#include <iostream>
#include "SnetPrint.h"


int main()
{
	SnetPrint snet( "snet" );
	Node s1, s2, s3, y1, y2, y3, y4, x1, x2, x3, x4, entry1, entry2, entry3, entry4, exit1, exit2, exit3, exit4;
	Edge e;

	y1 = snet.AddOuterEntry();
	y2 = snet.AddOuterEntry();
	y3 = snet.AddOuterEntry();
	y4 = snet.AddOuterEntry();
	x1 = snet.AddOuterExit();
	x2 = snet.AddOuterExit();
	x3 = snet.AddOuterExit();
	x4 = snet.AddOuterExit();

	s1 = snet.AddSubcentre( 4, 4 );
	s2 = snet.AddSubcentre( 2, 2 );
	s3 = snet.AddSubcentre( 2, 2 );

	entry1 = snet.FirstEntry( e, s1 );
	entry2 = snet.NextEntry( e );
	entry3 = snet.NextEntry( e );
	entry4 = snet.NextEntry( e );
	exit1 = snet.FirstExit( e, s1 );
	exit2 = snet.NextExit( e );
	exit3 = snet.NextExit( e );
	exit4 = snet.NextExit( e );

	snet.Connect( y1, entry1 );
	snet.Connect( y2, entry2 );
	snet.Connect( y3, entry3 );
	snet.Connect( y4, entry4 );

	entry1 = snet.FirstEntry( e, s2 );
	entry2 = snet.NextEntry( e );
	snet.Connect( exit1, entry1 );
	snet.Connect( exit2, entry2 );

	entry1 = snet.FirstEntry( e, s3 );
	entry2 = snet.NextEntry( e );
	snet.Connect( exit3, entry1 );
	snet.Connect( exit4, entry2 );

	exit1 = snet.FirstExit( e, s2 );
	exit2 = snet.NextExit( e );
	snet.Connect( exit1, x1 );
	snet.Connect( exit2, x2 );

	exit1 = snet.FirstExit( e, s3 );
	exit2 = snet.NextExit( e );
	snet.Connect( exit1, x3 );
	snet.Connect( exit2, x4 );
	snet.Print();

	NodeAttribute< int > color( 0 );

	color[ y1 ] = 1;
	color[ y2 ] = 2;
	color[ y3 ] = 3;
	color[ y4 ] = 4;

	color[ x1 ] = 4;
	color[ x2 ] = 3;
	color[ x3 ] = 2;
	color[ x4 ] = 1;

	NodeAttribute< Node > originalNode;
	SnetPrint complement( "Complement of snet" );
	snet.TransComplement( complement, originalNode );
	complement.Print();

	NodeAttribute< Relation > relation;
	NodeAttribute< bool > multible( false );
	bool ret = snet.ComputeRelations( color, multible, relation );

	if (ret )
		printf( "\nSUCCESS\n\n" );
	else
		printf( "\nERROR\n\n" );

	snet.PrintRelation( relation );
//	SnetPrint cc( "Complement of complement of snet" );
//	complement.TransComplement( cc, originalNode );
//	cc.Print();

	return 0;
}

